#!/usr/bin/perl -w

# utiliser le module
use XML::Simple;
use Data::Dumper;
use Unicode::String;
use utf8;

# Encodage de sortie
sub anglais ($)
{
	$keyword=shift;
	print $keyword."\n";
}

sub francais ($)
{
	$keyword=shift;
	print $keyword."\n";
}

sub alias_francais ($)
{
	$keyword=shift;
	print $keyword."\n";
}

sub html_titre($)
{
print <<FIN
<html>
	<head>
		<title>KTurle</title>
	</head>
	<body>
	<center>
	<h1>KLogo : Liste des mots cl&eacute;s en fran&ccedil;ais</h1>
	<table border=1>
	<tr><th>KeyWord</th><th>Mot Cl&eacute;</th>
FIN
;
}

sub html_fintitre($)
{
print <<FIN
	</tr></table>
	</center>
	</body>
	</html>
FIN
;
}

sub html_anglais ($)
{
	$keyword=shift;
	print "</tr><tr>\n<td>".$keyword."</td>\n";
}

sub html_francais ($)
{
	$keyword=shift;
	print "<td>".$keyword."</td>\n";
}

sub html_alias_francais ($)
{
	$keyword=shift;
	print "</tr><tr><td></td><td>".$keyword."</td>\n";
}

sub latex_titre($)
{
	print '\documentclass[a4paper,twocolumn]{article}'."\n";
	print '\input{entete.tex}'."\n";
	
	print <<FIN
\\begin{center}
\\begin{supertabular}{||c|c||}
\\hline
\\hline
\\b{KeyWord}	& \\b{Mot Clé}\\\\
\\hline
\\hline

FIN
;
}

sub latex_fintitre($)
{
	print <<FIN
\\hline
\\hline
\\end{supertabular}
\\end{center}
\\end{document}

FIN
;
}

sub latex_anglais ($)
{
	$keyword=shift;
	print "\\hline\n\\cellcolor{mongris}".$keyword;
}

sub latex_francais ($)
{
	$keyword=shift;
	print ' & '.$keyword."\\\\\n";
}

sub latex_alias_francais ($)
{
	$keyword=shift;
	print ' & '.$keyword."\\\\\n";
}

# Traitement des options
$encodage='latex';

$rsubtitre=\&{$encodage."_titre"};
$rsubfintitre=\&{$encodage."_fintitre"};
$rsubanglais=\&{$encodage."_anglais"};
$rsubfrancais=\&{$encodage."_francais"};
$rsubalias_francais=\&{$encodage."_alias_francais"};

# créer un objet
$xml = new XML::Simple ();

# lire le fichier XML
$data = $xml->XMLin("logo.xml");

# accéder aux données XML
#~ print Dumper ($data);

# Référence sur une structure de donnée (pointeur en C)
my $commande=$data->{'command'};
#~ print Dumper ($commande);


# Entête du tableau
&$rsubtitre;

foreach my $englogokey (sort (keys (%$commande)))
{
	&$rsubanglais ($englogokey);

	# frelogokey = drfrencement de commande (->) et lecture du hash $englogokey
	my $frelogokey=$commande->{$englogokey};

	&$rsubfrancais ($commande->{$englogokey}{'keyword'});
	&$rsubalias_francais ($commande->{$englogokey}{'alias'}) if defined ($commande->{$englogokey}{'alias'} );
}

&$rsubfintitre;

exit 0;